<?php

/**
 * UserRequest handler
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date:  08:53:00 -0400 (Fri, 04 Jun 2010) $
 * @version    	$Rev: 1854 $
 */
class ClxCommon {

    public static $db = null;
    public static $dbn = CLX_INIT_ZERO;
    public static $session = null;
    public static $bugs = null;
    public static $tools = array();
    public static $objects = array();
    public static $cached = array();
    public static $dbexrec = null;
    
    /**
     * Checks msg status
     * @param type $msg
     */
    static function checkMsgStatus(&$msg) {
        return (bool) (count($msg) === CLX_NUM_ZERO) ? true : false;
    }

    /**
     * Returns true if user has session false otherwise
     * @return boolean
     */
    static function sessionHasUser() {
        $ACUS = getTool('ACUS');
        return (bool) $ACUS->sessionHasUserItem();
    }

    /**
     * Return type
     * @return type
     */
    static function sessionUserIsAdmin() {
        return (!empty($_SESSION['user_record']['isadmin'])) ? true : false;
    }

}
