<?php

/**
 * General Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-09-03 16:24:19 +0000 (Thu, 03 Sep 2015) $
 * @version        $Rev: 6814 $
 * @package		Clientix.Classes.Tree
 * @abstract		General Tree Class
 * CHANGE LOG
 *  Included label
 */
class clx_datatree {

    var $root;
    var $start_tablecode;

    function clx_datatree($start_tablecode) {
        $this->start_tablecode = $start_tablecode;
        $this->error = false;
        $this->root = new clx_dataleaf('', '', CLX_NUM_ZERO, $this->start_tablecode, array());
    }

    function parse($form_fieldname, $elementid, $element, $formating_data) {
        $this->root->parse($this->start_tablecode, $form_fieldname, $elementid, $element, $formating_data);
    }

    function load($recordid, &$answers) {
        $record = array();
        return $this->root->load_dataleaf($recordid, $record, '', $answers);
    }

    function clear() {
        $this->root->clear();
    }

    function set(&$callback) {
        $this->root->set($callback);
    }

    function hasQuestion() {
        return $this->root->hasQuestion();
    }

    function hasErrors() {
        return $this->root->hasErrors();
    }

    function dump() {
        return $this->root->dump();
    }

}
