<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-09-03 12:24:19 -0400 (Thu, 03 Sep 2015) $
 * @version        $Rev: 6814 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Prpt {

    function __construct($procParameters = array()) {
        multiTableName($this, array('PRBE', 'GLCP', 'PRPT', 'FIAS', 'PROD'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->je_source = '';
    }

    /**
     * Validate record information
     * Executed on table validate
     *
     * @param array $record
     * @param array $msg
     */
    function validate_form(&$record, &$msg) {

    }

    function save_form(&$record) {
        if (!empty($record['ADVN_PROD_CODE']) && !empty($record['CONTRACT_CODE'])) {
		  $this->build_fias($record['CONTRACT_CODE'], 'AD', $record['ADVN_PROD_CODE']);
        }
        if (!empty($record['LOAN_PROD_CODE']) && !empty($record['CONTRACT_CODE'])) {
		  $this->build_fias($record['CONTRACT_CODE'], 'PR', $record['LOAN_PROD_CODE']);
        }
    }

    function build_fias($contract_code, $trust_item_type, $product_code) {
        //Verificando que
        $sql = 'SELECT FIAS.ID FROM ' . $this->fiasname . ' FIAS WHERE TRUST_ITEM_TYPE = ' . singleQuote($trust_item_type) . ' AND CONTRACT_CODE = ' . singleQuote($contract_code);
        $fias_code = ClxCommon::$db->getOne($sql);
        if (empty($fias_code)) {
		  $r = array('GL_TYPE' => 'AS', 'TRUST_ITEM_TYPE' => $trust_item_type, 'CONTRACT_CODE' => $contract_code);
		  $r['IDNAME'] = ClxCommon::$db->getField($this->prodname, 'IDNAME', 'IDCODE = ' . singleQuote($product_code));
		  if (!class_exists('Fias'))
			 includeCodeLib('FIAS');
		  $fias = new Fias();
		  $fias->fias_build($r);
        }
    }

}
