<?php

/**
 * Report Panel
 * For more information contact  support@alenet.com
 *
 * @author       $Author: imrsnik $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-09-17 19:28:59 +0000 (Thu, 17 Sep 2015) $
 * @version        $Rev: 6930 $
 * @package		Clientix.Classes.Report
 * @abstract		Abstract Class
 */
class clx_report_panel {

    /**
     * Panel Object
     * @var xReportObject
     */
    public $object;
    private $title;
    private $ln_post = CLX_INIT_ZERO;
    private $marginL = CLX_NUM_15;
    private $ln = true;
     
    function __construct(clx_report_object $object = null) {
        $this->addObject($object);
    }

    function addObject(clx_report_object $object = null) {
        $this->object = $object;
    }

    function getObject() {
        return $this->object;
    }

    function setTitle(clx_report_data $title) {
        $this->title = $title;
    }

    function getTitle() {
        return $this->title;
    }

    function setLnPost($ln_post = CLX_NUM_8) {
        $this->ln_post = $ln_post;
    }

    function getLnPost() {
        return $this->ln_post;
    }

    function setMarginL($left) {
        $this->marginL = $left;
    }

    function getMarginL() {
        return $this->marginL;
    }
    function getLn() {
	return $this->ln;
    }

}
