<?php

/**
 * General Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: imrsnik f$
 * @copyright    Alenet, Inc.
 * @since        $Date: 2016-06-09 10:58:28 -0400 (Thu, 09 Jun 2016) $
 * @version        $Rev: 8410 $
 * @package		Clientix.Classes.Webservice
 * @abstract		General Class
 * CHANGE LOG
 *  Included label
 * Created on Jul 28, 2008
 *
 * Implements any webservice call that may be required
 */
$GLOBALS['DEBUG_WEBSERVICE']=1; 
class webservice {

    /**
     * Any call handler
     * @param string $classname
     * @param string $parameters
     * @return string $call_result
     */
    function __call($classnane, $parameters) {		IF ($GLOBALS['DEBUG_WEBSERVICE']==1) {	$tta=fopen('temp/archivo.txt',"a+"); $te=debug_backtrace(); For ($t=0;$t<12;$t++) { /*if (isset($te[$t]["file"])){ */ 	fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9). $te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10)); 		/*}*/}fclose($tta);	$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).'_call webservice.php:28'.print_r($parameters,true).chr(13).chr(10)); fclose($kk);}
        //Verificar que servicios tienen tokens
       /// $this->initSession();

        //check if session parameter required and start session
        //$this->set_session_id_by_parameters($parameters);
        if (!defined('CLX_WEBSERVICE_EXEC')) {
		  define('CLX_WEBSERVICE_EXEC', CLX_NUM_ONE);
        }
		
        $call_result = null;
        $SKSV = &getTool('SKSV');
        $service = $SKSV->getServiceByName($classnane);
        //IF ($GLOBALS['DEBUG_WEBSERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' service '.print_r($service,true).' parameter '.print_r($parameters,true).chr(13).chr(10)); fclose($kk);}
        switch ($service['ACCESS_TYPE']) {
		  case 'CUSR':
		  case 'SUSR': //System user   // Se agrego para maejo de session token dqt3694kdpvv39l5ov85llcn75
				if (!empty($parameters[0]) && is_string($parameters[0]) && strlen($parameters[0])>22  ) {
					session_id($parameters[0]);
					IF ($GLOBALS['DEBUG_WEBSERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' SESSION_ID '.print_r($parameters[0],true).chr(13).chr(10)); fclose($kk);}	
					$this->initSession();
					unset ($parameters[0]);
					$parameters=array_values($parameters);
				}
			 $this->clxCheckSessionStatus(); //need revision
			 break;
		  case 'SUSF':  //Fixed user
			 $this->clxLoginFixUser($service['SYS_USERNAME']);
			 break;
		  case 'OPEN':
			 break;
		  default: //Open or any other
			 throw new SOAPFault('404', utf8_encode(dict('GEN_LBL_INVALID_REQUEST', false) . ' err.404 '), CLX_NUM_404);
			 salir(CLX_NUM_ZERO);
			 break;
        }
		if ($service == true) {  /// Ojo con triple igual no hace nada
		  $call_result = $SKSV->execute2($service['IDCODE'], $parameters);
        } else {
		  $call_result = false;
        }
        return (array_key_exists(CLX_NUM_ZERO, $call_result)) ? $call_result[CLX_NUM_ZERO] : $call_result;
    }

    /**
     * Test if session is active for user
     */
    private function clxCheckSessionStatus() {	IF ($GLOBALS['DEBUG_WEBSERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__. chr(13).chr(10)); fclose($kk);}       
        $ACUS = &getTool('ACUS');
		IF ($GLOBALS['DEBUG_WEBSERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.'sessionvalor : '. print_r($_SESSION, true). chr(13).chr(10)); fclose($kk);}
        if (!$ACUS->sessionHasUserItem()) {
		  throw new SOAPFault('401', utf8_encode(dict('GEN_LBL_SESSIONTIMEOUT', false) . ' err.401 '), CLX_NUM_401);
		  salir(CLX_NUM_ZERO);
        }
    }

    /**
     * Clientix Login
     * @param string $username
     * @param string $password
     * @return string $session_id
     */
    private function clxLoginFixUser($service_user) {		IF ($GLOBALS['DEBUG_WEBSERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.chr(13).chr(10)); fclose($kk);}
        $ACUS = &getTool('ACUS');
        if ($ACUS->userIsActive($service_user)) {
		  $ACUS->process_engine_login($service_user);
		  if (empty($ACUS->authenticated)) {
			 throw new SOAPFault(CLX_NUM_401, '401 ' . utf8_encode(dict('GEN_ERR_USERNAME_INVALID', false)));
			 salir(CLX_NUM_ZERO);
		  }
        } else {
		  throw new SOAPFault(CLX_NUM_401, '401 ' . utf8_encode(dict('GEN_ERR_USERNAME_INVALID', false)));
		  salir(CLX_NUM_ZERO);
        }
    }

    /**
     * Loads session with token if exists
     * @param type $session_token
     */
    private function initSession($session_token = '') {		IF ($GLOBALS['DEBUG_WEBSERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' request:'.print_r($_REQUEST,TRUE).chr(13).chr(10). chr(13).chr(10)); fclose($kk);}
        if ($session_token <> '') {
		  //Validate if token exists
		  session_id($session_token);
        }
        ClxCommon::$session = new ClxSession();
 
    }

    //--------------------------------------------------------------------------
    // CLX Methods
    //--------------------------------------------------------------------------

    /**
     * Test Service
     * @param void
     * @return string $info
     */
    public function clxTestService() {IF ($GLOBALS['DEBUG_WEBSERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.chr(13).chr(10).'request:'.print_r($_REQUEST,TRUE).chr(13).chr(10)); fclose($kk);}
        return 'CLX VER: ' . kSystemVersion .
			 ', SYS: ' . kDatabaseDisplay .
			 ', URI: ' . kWebSite . ', SID: ' . session_id();
    }

    /**
     * Returns Session data
     * @param string $session_token
     * @return string $session_data
     */
    public function clxGetSessionData($session_token) {	        //Initialize session token
        $this->initSession($session_token);IF ($GLOBALS['DEBUG_WEBSERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' GLOBALS '.print_r($GLOBALS,TRUE).' Token:'.print_r($session_token,true).chr(13).chr(10)); fclose($kk);}
        $return = '';
        if (ClxCommon::sessionHasUser()) {
		  $return = $_SESSION['user_record']['firstname'] . ' ' . $$_SESSION['user_record']['lastname'];
        } else {
		  throw new SOAPFault('404', utf8_encode(dict('GEN_LBL_UNAUTHORIZED', false) . ' err.404 '), CLX_NUM_404);
			salir(CLX_NUM_ZERO);
        }
        return $return;
    }

    /**
     * return session
     * @param void
     * @return string $info
     */
    public function clxGetSessionId() {IF ($GLOBALS['DEBUG_WEBSERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' GLOBALS '.print_r($GLOBALS,TRUE).' Token:'.print_r($session_token,true).chr(13).chr(10)); fclose($kk);}
        return (string) session_id();
    }

    /**
     * Clientix Login
     * @param string $username
     * @param string $password
     * @return string $session_token
     */
    public function clxLogin($username, $password) {
		$this->initSession();
        IF ($GLOBALS['DEBUG_WEBSERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' GLOBALS '.print_r($GLOBALS,TRUE).chr(13).chr(10)); fclose($kk);}		
        $ACUS = &getTool('ACUS');
        if (!$ACUS->sessionHasUserItem()) {
		  $ACUS->ws_login($username, $password);
		  if (empty($ACUS->authenticated)) {
			 throw new SOAPFault(CLX_NUM_401, '401 ' . utf8_encode(dict('GEN_ERR_USERNAME_INVALID', false)));
			 salir(CLX_NUM_ZERO);
		  }
        }
		IF ($GLOBALS['DEBUG_WEBSERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' ID_GENERADO: '.print_r(session_id(),TRUE).chr(13).chr(10)); fclose($kk);}		
        return session_id();
    }

    /**
     * Clientix Session Logout
     * @param string session_token
     * @return int $status
     */
    public function clxLogout($session_token) {
        //Initialize session token
        $this->initSession($session_token);IF ($GLOBALS['DEBUG_WEBSERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' GLOBALS '.print_r($GLOBALS,TRUE).' Token:'.print_r($session_token,true).chr(13).chr(10)); fclose($kk);}
        $this->clxCheckSessionStatus(); //need revision
        $ACUS = &getTool('ACUS');
        $ACUS->logout();
        return CLX_NUM_ONE;
    }

    /**
     * List Items Service
     * Service will return the items of a list
     * @param string $listcode
     * @param string @session_token
     * @return string $items
     */
    public function clxDbliGetListItems($listcode, $session_token) {
        //Initialize session token
        $this->initSession($session_token);IF ($GLOBALS['DEBUG_WEBSERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' GLOBALS '.print_r($GLOBALS,TRUE).' Token:'.print_r($session_token,true).chr(13).chr(10)); fclose($kk);}
        $this->clxCheckSessionStatus(); //need revision
        $this->clxCheckSessionStatus(); //throw error on fail
        $DBLT = &getTool('DBLT');
        return $DBLT->getListAsXml($listcode);
    }

    /**
     * Return query as xml values
     * @param string $querycode
     * @param string $critfieldname
     * @param string $critfieldvalue
     * @return string $results
     */
    public function clxDbqyGetQuery($querycode, $critfieldname, $critfieldvalue, $session_token) {
		$this->initSession($session_token);IF ($GLOBALS['DEBUG_WEBSERVICE']==1) {$kk=fopen('temp/saldebug.txt','a+');fwrite($kk, chr(13).chr(10).__METHOD__.' '.__FILE__.':'.__LINE__.' GLOBALS '.print_r($GLOBALS,TRUE).' Token:'.print_r($session_token,true).chr(13).chr(10)); fclose($kk);}
        $this->clxCheckSessionStatus(); //need revision
        $DBQY = &getTool('DBQY');
        return $DBQY->getResultXml('SKSV', $querycode, $critfieldname, $critfieldvalue);
    }

}
