<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-09-03 12:24:19 -0400 (Thu, 03 Sep 2015) $
 * @version        $Rev: 6814 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
/*
  Record of changes 			Desarrollo inicial
 */
if (!class_exists('ibs'))
    includeCodeLib('EIBS');
/*
  General Parameters:
  Librer�as de C�digo:
  Motor de Proceso:
  Cronograma:
  Depende de:
  tools/eb_sockets.php
  data/code/EIBS_utilities.php
  data/code/PROC_class_aid.php
  data/code/EIBS_util_ibiq.php
 */
/*
 * ******************************************************************************************************************
 * e-IBS Investment Portfolios Interface common properties and methods
 * *****************************************************************************************************************
 */

class ibs_infu_interface_commons extends ibs {
    /*
     * Constructor
     * @param text, array
     * @return void
     */

    function __construct($s_comp_code = null, $parameters = array()) {
        parent::__construct($this->s_comp_code, $parameters);
        if (!empty($this->debug)) {

        }
    }

// Method End
}

// Class End
/*
 * ******************************************************************************************************************
 * e-IBS Batch Investment Portfolios Interface
 * *****************************************************************************************************************
 */
class ibs_infu_batch_interface_commons extends ibs_infu_interface_commons {
    /*
     * Constructor
     * @param text, array
     * @return void
     */

    function ibs_infu_batch_interface_commons($s_comp_code = null, $parameters = array()) {
        parent::ibs_infu_interface_commons($s_comp_code, $parameters);
        if (!empty($this->debug)) {

        }
    }

// Method End
    /**
     * Builds a file for portfolio export File for Interfase
     * @param text
     * @return void
     */
    function portfolios_flat_file($filename) {

        $filename = kPathToWebSite . $filename;
        $handle = fopen($filename, 'w');
        $rs = ClxCommon::$db->executeQuery('SELECT IDCODE, IDNAME FROM ' . $this->infuname . ' WHERE 1=1');
        while ($result = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
            $line = implode(CLX_CHAR_TAB, $result) . CLX_CHAR_CR;
            /*
             * GEN_ERR_FILE_UNABLETOWRITE
             * Unable to write to file: ^1
             * No se pudo escribir el archivo: ^1
             */
            if (fwrite($handle, $line) === false)
                echo dict('GEN_ERR_FILE_UNABLETOWRITE', $filename), CLX_CHAR_NL;
        }
		ClxCommon::$db->freeResult($rs);
        fclose($handle);
        /*
         * GEN_LBL_PROCESS_COMPLETED
         * Process completed
         * Proceso terminado
         */
        echo dict('GEN_LBL_PROCESS_COMPLETED'), CLX_CHAR_NL;
    }

// Method End
}
