<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: imrsnik $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-09-25 07:56:58 -0400 (Fri, 25 Sep 2015) $
 * @version        $Rev: 7004 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Crit {

    function __construct($procParameters = array()) {
        multiTableName($this, array('PRAT'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->je_source = '';
    }

    /**
     * Validate record information
     * Executed on table validate
     *
     * @param array $record
     * @param array $msg
     */
    function validate_form(&$record, &$msg) {
	ClxFreeReturn($record);
	ClxFreeReturn($msg);
    }

    function init_form(&$record) {
        $history = peekHistory();
        if (!empty($history['parentrecord']['CRIC_EVAL_MODEL'])) {
		  $record['CRIT_EVAL_MODEL'] = $history['parentrecord']['CRIC_EVAL_MODEL'];
		  $record['CRIT_KPI_CAT'] = $history['parentrecord']['CRIC_KPI_CAT'];
		  $record['CRIT_IDCODE'] = $record['CRIT_EVAL_MODEL'] . '-' . $record['CRIT_KPI_CAT'] . '-0';
        }
    }

}
