<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-09-03 12:24:19 -0400 (Thu, 03 Sep 2015) $
 * @version        $Rev: 6814 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Figa {
    /* Contructor
     *
     * @param array $procParameters
     * @return void
     */

    function __construct($procParameters = array()) {
        multiTableName($this, array('FIGA', 'FICO', 'FIPA'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
    }

    /**
     * Initialice figa form
     * Executed on init event
     */
    function figa_init_form(&$record) {
        if (UserRequest::$request['ac'] === 'CREATE' || UserRequest::$request['ac'] === 'DUPLICATE') {

        }
        if (UserRequest::$request['ac'] === 'CREATE') {
		  if (!empty($record['FIGA_CONTRACT_CODE'])) {
			 if (!class_exists('Fico'))
			     includeCodeLib('FICO');
			 $fico = new Fico();
			 $comprec = $fico->fico_comp_operation_parameters($record['FIGA_CONTRACT_CODE']);
			 $record['FIGA_CLX_EFFTDATE'] = $comprec['OPERATION_DATE'];
		  }
        }
    }

    /**
     * Validate record information
     * Executed on table validate
     */
    function figa_validate_form(&$record, &$msg) {

    }

}
