<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
if (!class_exists('util') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'util.php';

class util_chmod extends util {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'PERM';
        $this->name = 'Folder Permitions';
        $this->type = 'UTIL';
        $this->version = '1.0.0.0';
        $this->description = 'This utility will set the correct permitions for share folders.';
        $this->haspanel = false;
    }

    function execute_() {
        $contents = '';
        $folders = array();
        $folders[] = kPathToWebSite . kPathToCode;
        $folders[] = kPathToWebSite . kPathToTemplates;
        $folders[] = kPathToWebSite . kPathToPackages;
        $folders[] = kPathToWebSite . kPathToTemp;
        pushHistory($this->code, 'IGNORE_THIS_ENTRY', CLX_NUM_ZERO);
        $form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->addArgument(CLX_PROP_TO, 'UTIL');
        $form->addArgument('ac', 'LIST');
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $table->addCell('Change Permitions', array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        foreach ($folders as $key => $val) {
		  $table->addCell(str_replace(kPathToWebSite, '', $val), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
		  //if(chmod($val, 777)){
		  $table->addCell('Ok', array(CLX_PROP_CLASS => CLX_CLASS_DATA));
		  /* }else{
		    $table->addCell('Fail',array( CLX_PROP_CLASS=> CLX_CLASS_DATA));
		    } */
        }
        $c = new htmlButtonReturn();
        $buttons = $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $contents = $form->source();
        return $contents;
    }

}

// End Class
